/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.docs_dispatcher.client.model.Address;
import io.docs_dispatcher.client.model.BasicListRequest;
import io.docs_dispatcher.client.model.BasicRequest;
import io.docs_dispatcher.client.model.ESignField;
import io.docs_dispatcher.client.model.ESignFileContentRequest;
import io.docs_dispatcher.client.model.ESignRequest;
import io.docs_dispatcher.client.model.EmailRequest;
import io.docs_dispatcher.client.model.FileContentRequest;
import io.docs_dispatcher.client.model.PostalRequest;
import io.docs_dispatcher.client.model.Recipient;
import io.docs_dispatcher.client.model.SMSRequest;
import io.docs_dispatcher.client.model.TargetRequest;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;



import java.io.IOException;
import java.lang.reflect.Type;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.JsonPrimitive;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonArray;
import com.google.gson.JsonParseException;

import io.docs_dispatcher.client.JSON;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2024-03-23T16:40:16.535479755Z[Etc/UTC]", comments = "Generator version: 7.5.0-SNAPSHOT")
public class CompositeRequest extends AbstractOpenApiSchema {
    private static final Logger log = Logger.getLogger(CompositeRequest.class.getName());

    public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
        @SuppressWarnings("unchecked")
        @Override
        public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
            if (!CompositeRequest.class.isAssignableFrom(type.getRawType())) {
                return null; // this class only serializes 'CompositeRequest' and its subtypes
            }
            final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
            final TypeAdapter<BasicRequest> adapterBasicRequest = gson.getDelegateAdapter(this, TypeToken.get(BasicRequest.class));
            final TypeAdapter<EmailRequest> adapterEmailRequest = gson.getDelegateAdapter(this, TypeToken.get(EmailRequest.class));
            final TypeAdapter<PostalRequest> adapterPostalRequest = gson.getDelegateAdapter(this, TypeToken.get(PostalRequest.class));
            final TypeAdapter<ESignRequest> adapterESignRequest = gson.getDelegateAdapter(this, TypeToken.get(ESignRequest.class));
            final TypeAdapter<SMSRequest> adapterSMSRequest = gson.getDelegateAdapter(this, TypeToken.get(SMSRequest.class));
            final TypeAdapter<BasicListRequest> adapterBasicListRequest = gson.getDelegateAdapter(this, TypeToken.get(BasicListRequest.class));

            return (TypeAdapter<T>) new TypeAdapter<CompositeRequest>() {
                @Override
                public void write(JsonWriter out, CompositeRequest value) throws IOException {
                    if (value == null || value.getActualInstance() == null) {
                        elementAdapter.write(out, null);
                        return;
                    }

                    // check if the actual instance is of the type `BasicRequest`
                    if (value.getActualInstance() instanceof BasicRequest) {
                      JsonElement element = adapterBasicRequest.toJsonTree((BasicRequest)value.getActualInstance());
                      elementAdapter.write(out, element);
                      return;
                    }
                    // check if the actual instance is of the type `EmailRequest`
                    if (value.getActualInstance() instanceof EmailRequest) {
                      JsonElement element = adapterEmailRequest.toJsonTree((EmailRequest)value.getActualInstance());
                      elementAdapter.write(out, element);
                      return;
                    }
                    // check if the actual instance is of the type `PostalRequest`
                    if (value.getActualInstance() instanceof PostalRequest) {
                      JsonElement element = adapterPostalRequest.toJsonTree((PostalRequest)value.getActualInstance());
                      elementAdapter.write(out, element);
                      return;
                    }
                    // check if the actual instance is of the type `ESignRequest`
                    if (value.getActualInstance() instanceof ESignRequest) {
                      JsonElement element = adapterESignRequest.toJsonTree((ESignRequest)value.getActualInstance());
                      elementAdapter.write(out, element);
                      return;
                    }
                    // check if the actual instance is of the type `SMSRequest`
                    if (value.getActualInstance() instanceof SMSRequest) {
                      JsonElement element = adapterSMSRequest.toJsonTree((SMSRequest)value.getActualInstance());
                      elementAdapter.write(out, element);
                      return;
                    }
                    // check if the actual instance is of the type `BasicListRequest`
                    if (value.getActualInstance() instanceof BasicListRequest) {
                      JsonElement element = adapterBasicListRequest.toJsonTree((BasicListRequest)value.getActualInstance());
                      elementAdapter.write(out, element);
                      return;
                    }
                    throw new IOException("Failed to serialize as the type doesn't match oneOf schemas: BasicListRequest, BasicRequest, ESignRequest, EmailRequest, PostalRequest, SMSRequest");
                }

                @Override
                public CompositeRequest read(JsonReader in) throws IOException {
                    Object deserialized = null;
                    JsonElement jsonElement = elementAdapter.read(in);

                    int match = 0;
                    ArrayList<String> errorMessages = new ArrayList<>();
                    TypeAdapter actualAdapter = elementAdapter;

                    // deserialize BasicRequest
                    try {
                      // validate the JSON object to see if any exception is thrown
                      BasicRequest.validateJsonElement(jsonElement);
                      actualAdapter = adapterBasicRequest;
                      match++;
                      log.log(Level.FINER, "Input data matches schema 'BasicRequest'");
                    } catch (Exception e) {
                      // deserialization failed, continue
                      errorMessages.add(String.format("Deserialization for BasicRequest failed with `%s`.", e.getMessage()));
                      log.log(Level.FINER, "Input data does not match schema 'BasicRequest'", e);
                    }
                    // deserialize EmailRequest
                    try {
                      // validate the JSON object to see if any exception is thrown
                      EmailRequest.validateJsonElement(jsonElement);
                      actualAdapter = adapterEmailRequest;
                      match++;
                      log.log(Level.FINER, "Input data matches schema 'EmailRequest'");
                    } catch (Exception e) {
                      // deserialization failed, continue
                      errorMessages.add(String.format("Deserialization for EmailRequest failed with `%s`.", e.getMessage()));
                      log.log(Level.FINER, "Input data does not match schema 'EmailRequest'", e);
                    }
                    // deserialize PostalRequest
                    try {
                      // validate the JSON object to see if any exception is thrown
                      PostalRequest.validateJsonElement(jsonElement);
                      actualAdapter = adapterPostalRequest;
                      match++;
                      log.log(Level.FINER, "Input data matches schema 'PostalRequest'");
                    } catch (Exception e) {
                      // deserialization failed, continue
                      errorMessages.add(String.format("Deserialization for PostalRequest failed with `%s`.", e.getMessage()));
                      log.log(Level.FINER, "Input data does not match schema 'PostalRequest'", e);
                    }
                    // deserialize ESignRequest
                    try {
                      // validate the JSON object to see if any exception is thrown
                      ESignRequest.validateJsonElement(jsonElement);
                      actualAdapter = adapterESignRequest;
                      match++;
                      log.log(Level.FINER, "Input data matches schema 'ESignRequest'");
                    } catch (Exception e) {
                      // deserialization failed, continue
                      errorMessages.add(String.format("Deserialization for ESignRequest failed with `%s`.", e.getMessage()));
                      log.log(Level.FINER, "Input data does not match schema 'ESignRequest'", e);
                    }
                    // deserialize SMSRequest
                    try {
                      // validate the JSON object to see if any exception is thrown
                      SMSRequest.validateJsonElement(jsonElement);
                      actualAdapter = adapterSMSRequest;
                      match++;
                      log.log(Level.FINER, "Input data matches schema 'SMSRequest'");
                    } catch (Exception e) {
                      // deserialization failed, continue
                      errorMessages.add(String.format("Deserialization for SMSRequest failed with `%s`.", e.getMessage()));
                      log.log(Level.FINER, "Input data does not match schema 'SMSRequest'", e);
                    }
                    // deserialize BasicListRequest
                    try {
                      // validate the JSON object to see if any exception is thrown
                      BasicListRequest.validateJsonElement(jsonElement);
                      actualAdapter = adapterBasicListRequest;
                      match++;
                      log.log(Level.FINER, "Input data matches schema 'BasicListRequest'");
                    } catch (Exception e) {
                      // deserialization failed, continue
                      errorMessages.add(String.format("Deserialization for BasicListRequest failed with `%s`.", e.getMessage()));
                      log.log(Level.FINER, "Input data does not match schema 'BasicListRequest'", e);
                    }

                    if (match == 1) {
                        CompositeRequest ret = new CompositeRequest();
                        ret.setActualInstance(actualAdapter.fromJsonTree(jsonElement));
                        return ret;
                    }

                    throw new IOException(String.format("Failed deserialization for CompositeRequest: %d classes match result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", match, errorMessages, jsonElement.toString()));
                }
            }.nullSafe();
        }
    }

    // store a list of schema names defined in oneOf
    public static final Map<String, Class<?>> schemas = new HashMap<String, Class<?>>();

    public CompositeRequest() {
        super("oneOf", Boolean.FALSE);
    }

    public CompositeRequest(BasicListRequest o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CompositeRequest(BasicRequest o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CompositeRequest(ESignRequest o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CompositeRequest(EmailRequest o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CompositeRequest(PostalRequest o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CompositeRequest(SMSRequest o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    static {
        schemas.put("BasicRequest", BasicRequest.class);
        schemas.put("EmailRequest", EmailRequest.class);
        schemas.put("PostalRequest", PostalRequest.class);
        schemas.put("ESignRequest", ESignRequest.class);
        schemas.put("SMSRequest", SMSRequest.class);
        schemas.put("BasicListRequest", BasicListRequest.class);
    }

    @Override
    public Map<String, Class<?>> getSchemas() {
        return CompositeRequest.schemas;
    }

    /**
     * Set the instance that matches the oneOf child schema, check
     * the instance parameter is valid against the oneOf child schemas:
     * BasicListRequest, BasicRequest, ESignRequest, EmailRequest, PostalRequest, SMSRequest
     *
     * It could be an instance of the 'oneOf' schemas.
     */
    @Override
    public void setActualInstance(Object instance) {
        if (instance instanceof BasicRequest) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof EmailRequest) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof PostalRequest) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof ESignRequest) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof SMSRequest) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof BasicListRequest) {
            super.setActualInstance(instance);
            return;
        }

        throw new RuntimeException("Invalid instance type. Must be BasicListRequest, BasicRequest, ESignRequest, EmailRequest, PostalRequest, SMSRequest");
    }

    /**
     * Get the actual instance, which can be the following:
     * BasicListRequest, BasicRequest, ESignRequest, EmailRequest, PostalRequest, SMSRequest
     *
     * @return The actual instance (BasicListRequest, BasicRequest, ESignRequest, EmailRequest, PostalRequest, SMSRequest)
     */
    @Override
    public Object getActualInstance() {
        return super.getActualInstance();
    }

    /**
     * Get the actual instance of `BasicRequest`. If the actual instance is not `BasicRequest`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `BasicRequest`
     * @throws ClassCastException if the instance is not `BasicRequest`
     */
    public BasicRequest getBasicRequest() throws ClassCastException {
        return (BasicRequest)super.getActualInstance();
    }
    /**
     * Get the actual instance of `EmailRequest`. If the actual instance is not `EmailRequest`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `EmailRequest`
     * @throws ClassCastException if the instance is not `EmailRequest`
     */
    public EmailRequest getEmailRequest() throws ClassCastException {
        return (EmailRequest)super.getActualInstance();
    }
    /**
     * Get the actual instance of `PostalRequest`. If the actual instance is not `PostalRequest`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `PostalRequest`
     * @throws ClassCastException if the instance is not `PostalRequest`
     */
    public PostalRequest getPostalRequest() throws ClassCastException {
        return (PostalRequest)super.getActualInstance();
    }
    /**
     * Get the actual instance of `ESignRequest`. If the actual instance is not `ESignRequest`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `ESignRequest`
     * @throws ClassCastException if the instance is not `ESignRequest`
     */
    public ESignRequest getESignRequest() throws ClassCastException {
        return (ESignRequest)super.getActualInstance();
    }
    /**
     * Get the actual instance of `SMSRequest`. If the actual instance is not `SMSRequest`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `SMSRequest`
     * @throws ClassCastException if the instance is not `SMSRequest`
     */
    public SMSRequest getSMSRequest() throws ClassCastException {
        return (SMSRequest)super.getActualInstance();
    }
    /**
     * Get the actual instance of `BasicListRequest`. If the actual instance is not `BasicListRequest`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `BasicListRequest`
     * @throws ClassCastException if the instance is not `BasicListRequest`
     */
    public BasicListRequest getBasicListRequest() throws ClassCastException {
        return (BasicListRequest)super.getActualInstance();
    }

 /**
  * Validates the JSON Element and throws an exception if issues found
  *
  * @param jsonElement JSON Element
  * @throws IOException if the JSON Element is invalid with respect to CompositeRequest
  */
  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
    // validate oneOf schemas one by one
    int validCount = 0;
    ArrayList<String> errorMessages = new ArrayList<>();
    // validate the json string with BasicRequest
    try {
      BasicRequest.validateJsonElement(jsonElement);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for BasicRequest failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with EmailRequest
    try {
      EmailRequest.validateJsonElement(jsonElement);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for EmailRequest failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with PostalRequest
    try {
      PostalRequest.validateJsonElement(jsonElement);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for PostalRequest failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with ESignRequest
    try {
      ESignRequest.validateJsonElement(jsonElement);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for ESignRequest failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with SMSRequest
    try {
      SMSRequest.validateJsonElement(jsonElement);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for SMSRequest failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with BasicListRequest
    try {
      BasicListRequest.validateJsonElement(jsonElement);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for BasicListRequest failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    if (validCount != 1) {
      throw new IOException(String.format("The JSON string is invalid for CompositeRequest with oneOf schemas: BasicListRequest, BasicRequest, ESignRequest, EmailRequest, PostalRequest, SMSRequest. %d class(es) match the result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", validCount, errorMessages, jsonElement.toString()));
    }
  }

 /**
  * Create an instance of CompositeRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CompositeRequest
  * @throws IOException if the JSON string is invalid with respect to CompositeRequest
  */
  public static CompositeRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CompositeRequest.class);
  }

 /**
  * Convert an instance of CompositeRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

